use strict;
use Win32::OLE qw(in with);
use Win32::OLE::Const 'Microsoft Excel';


# Start, and open spreadsheet.
#                           
my $Excel = Win32::OLE->GetActiveObject('Excel.Application')
    || Win32::OLE->new('Excel.Application', 'Quit');  
my $Book = $Excel->Workbooks->Open("C:\\test\\test15.xls"); 


# Switch off warnings and pop-ups, I hope.
#
$Win32::OLE::Warn = 0;
$Excel->{DisplayAlerts}=0;   

# Let me see the spreadsheet.
#
$Excel->{Visible}=1;   

# Am about to put a value (the time) into A1, then
# call a macro that has a divide-by-0 error.
# The macro updates cell A1 first. After.
# calling the macro, see whether A1 has changed.
# Also display the last OLE error.
#
my $time = localtime;
print "Am about to put \"" . $time . "\" into A1.\n"; 
$Excel->Sheets("Sheet1")->Range("A1")->{Value} = $time;
my $A1 = $Excel->Sheets("Sheet1")->Range("A1")->{Text};
print "A1 before calling first macro = \"" . $A1 . "\".\n"; 
print "Am about to call macro.\n"; 
$Excel->Run("ProvokeDivError1");
my $error = Win32::OLE->LastError();
print "Error = " . $error . ".\n";
$A1 = $Excel->Sheets("Sheet1")->Range("A1")->{Text};
print "A1 after calling macro = \"" . $A1 . "\".\n\n";  

print "After first macro call and before second one.\n\n";

# Now the same for the second macro, but
# with A2.
#
my $time = localtime;
print "Am about to put \"" . $time . "\" into A2.\n"; 
$Excel->Sheets("Sheet1")->Range("A2")->{Value} = $time;
my $A2 = $Excel->Sheets("Sheet1")->Range("A2")->{Text};
print "A2 before calling second macro = \"" . $A2 . "\".\n"; 
print "Am about to call macro.\n"; 
$Excel->Run("ProvokeDivError2");
$error = Win32::OLE->LastError();
print "Error = " . $error . ".\n";
$A2 = $Excel->Sheets("Sheet1")->Range("A2")->{Text};
print "A2 after calling macro = \"" . $A2 . "\".\n\n";  

print "After second macro call.\n\n";

# Demonstrate that spreadsheet is still
# working, and usable for calculation.
#
$time = localtime;
print "Am about to put \"" . $time . "\" into A3.\n"; 
$Excel->Sheets("Sheet1")->Range("A3")->{Value} = $time;
my $A3 = $Excel->Sheets("Sheet1")->Range("A3")->{Text};
print "A3 = \"" . $A3 . "\".\n"; 
my $A4 = $Excel->Sheets("Sheet1")->Range("A4")->{Text};
print "A4 is defined to be this appended to itself:\n";
print "A4 = \"" . $A4 . "\".\n";
